> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tight.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Save transaction rules

> Save new (or update existing) transaction rules



## OpenAPI

````yaml https://dev.tight.com/v3/api-docs post /v6/banks/transactions/rules
openapi: 3.0.1
info:
  title: Tight API
  contact:
    name: Hurdlr, Inc. (dba Tight)
    url: https://www.tight.com
    email: api@tight.com
  version: 6.0.0
servers:
  - url: https://sandbox.tight.com
    description: Staging Environment
  - url: https://prod.tight.com
    description: Production Environment
security:
  - EmbedToken: []
paths:
  /v6/banks/transactions/rules:
    post:
      tags:
        - Transaction Rules
      summary: Save transaction rules
      description: Save new (or update existing) transaction rules
      operationId: postTransactionRules
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MultiParamTransactionRulePostDto'
        required: true
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/ResponseListMultiResponseTransactionRuleGetDto
        '207':
          description: >-
            Some transaction rules failed to save. See response body for error
            details.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/ResponseListMultiResponseTransactionRuleGetDto
        '400':
          description: All transaction rules failed to save.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/ResponseListMultiResponseTransactionRuleGetDto
        '401':
          description: Not authenticated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: INVALID_TOKEN
                    message: Invalid access token
        '403':
          description: Not authorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: FORBIDDEN
                    message: Expired access token
        '404':
          description: Endpoint not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: BAD_REQUEST
                    message: Resource not found
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: UNKNOWN_ERROR
                    message: Something went wrong. Please try again later.
      security:
        - EmbedToken: []
components:
  schemas:
    MultiParamTransactionRulePostDto:
      required:
        - data
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/TransactionRulePostDto'
    ResponseListMultiResponseTransactionRuleGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: array
          description: The data generated by the action performed.
          items:
            $ref: '#/components/schemas/MultiResponseTransactionRuleGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    ErrorResponse:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: object
          description: The data generated by the action performed.
          nullable: true
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    TransactionRulePostDto:
      type: object
      properties:
        id:
          type: string
          description: Id of the transaction rule, required when updating an existing rule
          example: trl_5445116
        status:
          type: string
          description: Status of the transaction rule
          nullable: false
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        filter:
          $ref: '#/components/schemas/TransactionRuleFilterPostDto'
        update:
          $ref: '#/components/schemas/TransactionRuleUpdatePostDto'
        applyToExistingTransactions:
          type: boolean
          description: >-
            Whether or not to apply this rule to all existing transactions. Will
            overwrite fields on existing transactions
          default: false
        customData:
          $ref: '#/components/schemas/JsonNode'
    MultiResponseTransactionRuleGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        statusCode:
          $ref: '#/components/schemas/HttpStatus'
        data:
          $ref: '#/components/schemas/TransactionRuleGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
      description: The data generated by the action performed.
    ErrorItem:
      type: object
      properties:
        type:
          type: string
          description: The type of the error. Safe for programmatic use.
          enum:
            - UNKNOWN_ERROR
            - INVALID_TOKEN
            - EXPIRED_TOKEN
            - FORBIDDEN
            - BAD_REQUEST
            - JSON_ERROR
            - DUPLICATE
            - REQUIRED
            - INVALID_VALUE
            - NOT_MODIFIABLE
            - INVALID_FORMAT
            - NOT_FOUND
        message:
          type: string
          description: >-
            A human-readable message providing more details about the error.
            Safe for displaying to a user.
        param:
          type: string
          description: >-
            If the error is parameter-specific, the parameter related to the
            error. This can be used to display a message near the correct form
            field.
      description: Errors associated with the action performed, if applicable.
    TransactionRuleFilterPostDto:
      type: object
      properties:
        description:
          $ref: '#/components/schemas/DescriptionCondition'
        amount:
          $ref: '#/components/schemas/AmountCondition'
        vendor:
          $ref: '#/components/schemas/VendorCondition'
        glAccount:
          $ref: '#/components/schemas/GlAccountCondition'
        bankAccount:
          $ref: '#/components/schemas/BankAccountCondition'
      description: Filter criteria defining which transactions this rule matches
      nullable: false
    TransactionRuleUpdatePostDto:
      type: object
      properties:
        glAccountId:
          type: string
          description: GlAccount to assign to matched transactions
          nullable: false
          example: gla_58932890
        vendorId:
          type: string
          description: Vendor to assign to matched transactions
          nullable: false
          example: vnd_28868401
        customerId:
          type: string
          description: Customer to assign to matched transactions
          nullable: false
          example: cus_4852707
        reviewStatus:
          type: string
          description: Review status to assign to matched transactions
          nullable: false
          example: RECONCILED
          enum:
            - RECONCILIATION_DISCREPANCY
            - USER_REVIEW_REQUIRED
            - ACCOUNTANT_REVIEW_REQUIRED
            - PARTNER_REVIEW_REQUIRED
            - AWAITING_MATCH
            - STAGED
            - RECONCILED
        dimensionValueIds:
          type: array
          nullable: false
          items:
            type: string
            description: Dimension values to assign to matched transactions
            example: dv_12345678
      description: Updates to apply to matched transactions
      nullable: false
    JsonNode:
      type: object
      properties:
        empty:
          type: boolean
        array:
          type: boolean
        'null':
          type: boolean
        object:
          type: boolean
        float:
          type: boolean
        string:
          type: boolean
        number:
          type: boolean
        missingNode:
          type: boolean
        valueNode:
          type: boolean
        nodeType:
          type: string
          enum:
            - ARRAY
            - BINARY
            - BOOLEAN
            - MISSING
            - 'NULL'
            - NUMBER
            - OBJECT
            - POJO
            - STRING
        pojo:
          type: boolean
        integralNumber:
          type: boolean
        floatingPointNumber:
          type: boolean
        short:
          type: boolean
        int:
          type: boolean
        long:
          type: boolean
        double:
          type: boolean
        bigDecimal:
          type: boolean
        bigInteger:
          type: boolean
        textual:
          type: boolean
          deprecated: true
        boolean:
          type: boolean
        binary:
          type: boolean
        container:
          type: boolean
        embeddedValue:
          type: boolean
      description: >-
        Custom JSON in which you can store any data with max length of 2000
        characters
      nullable: true
      example:
        internal_key: some_internal_key
        some_other_field: 23434
    HttpStatus:
      type: integer
      description: The HTTP status code for the action performed.
      format: int32
      enum:
        - 200
        - 400
        - 401
        - 403
        - 404
        - 500
    TransactionRuleGetDto:
      required:
        - filter
        - filterDisplayName
        - id
        - lastAppliedDateTime
        - matchCount
        - status
        - update
        - updateDisplayName
      type: object
      properties:
        id:
          type: string
          description: Id of the transaction rule
          example: trl_5445116
        status:
          type: string
          description: Status of the transaction rule
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        filter:
          $ref: '#/components/schemas/TransactionRuleFilterDto'
        update:
          $ref: '#/components/schemas/TransactionRuleUpdateGetDto'
        matchCount:
          type: integer
          description: Number of matched transactions for the transaction rule
          format: int64
          example: 4
        lastAppliedDateTime:
          type: string
          description: Date on which the most recent match occurred of the transaction rule
          format: date-time
        filterDisplayName:
          type: string
          description: Description of the filter conditions of the transaction rule
          example: Vendor is "Starbucks"
        updateDisplayName:
          type: string
          description: Description of the updates applied by the transaction rule
          example: Set glAccount as "Taxi"
        customData:
          $ref: '#/components/schemas/JsonNode'
      description: The data generated by the action performed.
    DescriptionCondition:
      type: object
      properties:
        equal:
          type: string
          description: Exact match on transaction description
          example: Office Supplies
        contain:
          type: string
          description: Contains match on transaction description
          example: Supplies
      description: Filter by transaction description
      nullable: false
    AmountCondition:
      type: object
      properties:
        equal:
          type: integer
          description: Exact amount match
          format: int32
        greaterThan:
          type: integer
          description: Amount greater than
          format: int32
        greaterThanEqual:
          type: integer
          description: Amount greater than or equal
          format: int32
        lessThan:
          type: integer
          description: Amount less than
          format: int32
        lessThanEqual:
          type: integer
          description: Amount less than or equal
          format: int32
      description: Filter by transaction amount
      nullable: false
    VendorCondition:
      type: object
      properties:
        id:
          $ref: '#/components/schemas/IdCondition'
      description: Filter by vendor
      nullable: false
    GlAccountCondition:
      type: object
      properties:
        id:
          $ref: '#/components/schemas/IdCondition'
      description: Filter by GL account
      nullable: false
    BankAccountCondition:
      type: object
      properties:
        id:
          $ref: '#/components/schemas/IdCondition'
      description: Filter by bank account
      nullable: false
    TransactionRuleFilterDto:
      type: object
      properties:
        description:
          $ref: '#/components/schemas/DescriptionCondition'
        amount:
          $ref: '#/components/schemas/AmountCondition'
        vendor:
          $ref: '#/components/schemas/VendorCondition'
        glAccount:
          $ref: '#/components/schemas/GlAccountCondition'
        bankAccount:
          $ref: '#/components/schemas/BankAccountCondition'
      description: Filter criteria defining which transactions this rule matches
      nullable: true
    TransactionRuleUpdateGetDto:
      required:
        - customer
        - dimensionValues
        - glAccount
        - reviewStatus
        - vendor
      type: object
      properties:
        glAccount:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/GlAccountExpanded'
        vendor:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/VendorExpanded'
        customer:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/CustomerExpanded'
        reviewStatus:
          type: string
          description: Review status assigned to matched transactions
          nullable: true
          example: RECONCILED
          enum:
            - RECONCILIATION_DISCREPANCY
            - USER_REVIEW_REQUIRED
            - ACCOUNTANT_REVIEW_REQUIRED
            - PARTNER_REVIEW_REQUIRED
            - AWAITING_MATCH
            - STAGED
            - RECONCILED
        dimensionValues:
          maxItems: 4
          type: array
          items:
            $ref: '#/components/schemas/DimensionValueExpanded'
      description: Updates to apply to matched transactions
      nullable: true
    IdCondition:
      type: object
      properties:
        equal:
          type: string
          description: Exact match on template GL account id
          example: tgla_324231
      description: Filter by template GL account id
    GlAccountExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the GL account
          example: gla_38560327
        name:
          type: string
          description: Name of the GL account
          example: Officer(s) Salaries and Wages
        accountNo:
          type: string
          description: Number of the GL account
          example: '60210'
        type:
          type: string
          description: Type the GL account
          example: EXPENSE
          enum:
            - ASSET
            - LIABILITY
            - EQUITY
            - INCOME
            - COGS
            - EXPENSE
            - OTHER_INCOME
            - OTHER_EXPENSE
            - SUSPENSE
        iconUrl:
          type: string
          description: Icon URL of the GL account
          example: https://cdn.sandbox.tight.com/icons/glAccountTypes/expense.png
        displayName:
          type: string
          description: Display name of the GL account
          example: '#60210 Officer(s) Salaries and Wages'
      description: GL account details
    VendorExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the vendor
          example: vnd_28868401
        name:
          type: string
          description: Name of the vendor
          example: Gusto
      description: Vendor associated with this child payment
      nullable: true
    CustomerExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the customer
          example: cus_4852707
        name:
          type: string
          description: Name of the customer
          example: Abigail Adams
        email:
          type: string
          description: Email of the customer
          example: abigail@tight.com
      description: Customer associated with this time entry
      nullable: true
    DimensionValueExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the dimension value
          example: dv_593051
        dimension:
          $ref: '#/components/schemas/DimensionExpanded'
        name:
          type: string
          description: Name of the dimension value
          example: Mid-Atlantic
        child:
          $ref: '#/components/schemas/ChildDimensionValue'
      description: List of dimension values associated with this time entry
    DimensionExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the dimension
          example: dim_4521
        name:
          type: string
          description: Name of the dimension
          example: Region
        requiredness:
          type: string
          description: Requiredness of the dimension
          example: NOT_REQUIRED
          enum:
            - REQUIRED
            - NOT_REQUIRED
      description: Dimension for this dimension value
    ChildDimensionValue:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the dimension value
          example: dv_593052
        dimension:
          $ref: '#/components/schemas/DimensionExpanded'
        name:
          type: string
          description: Name of the dimension value
          example: Washington DC
        child:
          $ref: '#/components/schemas/ChildDimensionValue'
      description: Child dimension value, if applicable
  securitySchemes:
    EmbedToken:
      type: http
      description: >-
        Bearer authentication header of the form `Bearer <token>`, see
        [Authentication for more
        detail](/api-reference/authentication#partner-level-authentication).
      scheme: bearer

````